woj 1010 Alternate Sum

2024-02-06 06:32
文章标签 sum 1010 alternate woj

本文主要是介绍woj 1010 Alternate Sum,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

证明结论之后很简单。考虑集合中每个元素最终对和的贡献:

(1)考虑集合中最大的一个元素,设为t,则在有 t 的子集中,求Alternate Sum时 t 一定是+的(因为它排序后只能在第一个位置),这样的集合有2 ^ (n - 1) 个,从而 t 的贡献为t * 2 ^ (n - 1);

(2)考虑集合中第二大的元素 t1,它要在子集合中求Alternate Sum时以 - 的形式出现,则该子集必包含第一个元素,这样的集合有2 ^ (n - 2)个,不包含第一个元素的集合也有2 ^ (n - 2)个,所以所有包含 t1 的子集合的Alternate Sum求和时 t1 贡献为0;

(3)考虑集合中第三大的元素 t2,易知 t2 为 - 的情况有2 ^ (n - 2)种(分别是:包含第一个元素但不包含第二个元素:2 ^ (n - 3),包含第二个元素但不包含第一个元素:2 ^ (n - 3)),为 + 的情况有2 ^ (n - 2)种(分别是:同时包含第一个、第二个元素:2 ^ (n - 3),同时不包含第一个、第二个元素:2 ^ (n - 3)),所以所有包含 t2 的子集合的Alternate Sum求和时 t2 的贡献为0;

……

从而最终的结果是:max(Q) * 2 (|Q| - 1)

/** Author: stormdpzh* Created Time: 2012/7/12 16:33:32* File Name: woj_1010.cpp*/
#include <iostream>
#include <cstdio>
#include <sstream>
#include <cstring>
#include <string>
#include <cmath>
#include <vector>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <algorithm>
#include <functional>#define sz(v) ((int)(v).size())
#define rep(i, n) for(int i = 0; i < n; i++)
#define repf(i, a, b) for(int i = a; i <= b; i++)
#define repd(i, a, b) for(int i = a; i >= b; i--)
#define out(n) printf("%d\n", n)
#define mset(a, b) memset(a, b, sizeof(a))
#define wh(n) while(1 == scanf("%d", &n))
#define whz(n) while(1 == scanf("%d", &n) && n != 0)
#define lint long longusing namespace std;const int MaxN = 1 << 30;int main()
{int n;whz(n) {int maxx;scanf("%d", &maxx);rep(i, n - 1) {int tmp;scanf("%d", &tmp);maxx = max(maxx, tmp);}maxx %= 2006;if(maxx < 0) maxx += 2006;rep(i, n - 1) {maxx *= 2;maxx %= 2006;}printf("%d\n", maxx % 2006);}return 0;
}


这篇关于woj 1010 Alternate Sum的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/683420

相关文章

最大流=最小割=最小点权覆盖集=sum-最大点权独立集

二分图最小点覆盖和最大独立集都可以转化为最大匹配求解。 在这个基础上,把每个点赋予一个非负的权值,这两个问题就转化为:二分图最小点权覆盖和二分图最大点权独立集。   二分图最小点权覆盖     从x或者y集合中选取一些点,使这些点覆盖所有的边,并且选出来的点的权值尽可能小。 建模:     原二分图中的边(u,v)替换为容量为INF的有向边(u,v),设立源点s和汇点t

如何导入sun.misc.BASE64Encoder和sum.misc.BASE64Decoder

右击项目名--->Build Path--->Configure Build Path...--->java Build Path--->Access rules:1 rule defined,added to all librar...   --->Edit --->Add...

18. 4 Sum

题目: 解答: 与之前的三数之和的解法类似,也是先排序,然后不断剔除不可能的条件,最后两个参数,通过两头求和计算得出。 代码: class Solution {public:vector<vector<int>> fourSum(vector<int>& nums, int target) {vector<vector<int>> result;int len = nums.size

apt-get update更新源时,出现“Hash Sum mismatch”问题

转载自:apt-get update更新源时,出现“Hash Sum mismatch”问题 当使用apt-get update更新源时,出现下面“Hash Sum mismatch”的报错,具体如下: root@localhost:~# apt-get update ...... ...... W: Failed to fetch http://us.archive.ubuntu.com/ub

HDU 1010 Tempter of the Bone (搜索)

OJ题目 : click here ~~ 大概题意 : 迷宫搜索。从起点到终点 ,不能回头 , 问能不能在恰好在T 时刻,准时到达终点。 本题充分体现了剪枝的重要性: 奇偶性剪枝: 可以把maze看成这样:  0 1 0 1 0 1  1 0 1 0 1 0  0 1 0 1 0 1  1 0 1 0 1 0  0 1 0 1 0 1  从为 0 的格子走一步,必然走向为 1 的格子

[LeetCode] 303. Range Sum Query - Immutable

题:https://leetcode.com/problems/range-sum-query-immutable/description/ 题目 Given an integer array nums, find the sum of the elements between indices i and j (i ≤ j), inclusive. Example: Given nums

[LeetCode] 64. Minimum Path Sum

题:https://leetcode.com/problems/minimum-path-sum/description/ 题目 Given a m x n grid filled with non-negative numbers, find a path from top left to bottom right which minimizes the sum of all numbers

[LeetCode] 404. Sum of Left Leaves

题:https://leetcode.com/problems/sum-of-left-leaves/description/ 题目 Find the sum of all left leaves in a given binary tree. Example: 3/ \9 20/ \15 7There are two left leaves in the binary t

数论 --- 费马小定理 + 快速幂 HDU 4704 Sum

Sum  Problem's Link:   http://acm.hdu.edu.cn/showproblem.php?pid=4704   Mean:  给定一个大整数N,求1到N中每个数的因式分解个数的总和。   analyse: N可达10^100000,只能用数学方法来做。 首先想到的是找规律。通过枚举小数据来找规律,发现其实answer=pow(2,n-1);

LeetCode - 40. Combination Sum II

40. Combination Sum II  Problem's Link  ---------------------------------------------------------------------------- Mean:  给你一个待选集合s和一个数n,选出所有相加之和为n的组合.(每个元素只能选一次) analyse: 递归求解. 在递归进入